<?php

/*
 *	Copyright 2011-2013 Benjamin Ingle
 *	The PSyOPs framework is licensed 
 *	under the GNU LGPL, version 2.1
 *	http://www.gnu.org/licenses/old-licenses/lgpl-2.1.txt
 */

/*	//DEBUG
 foreach($_POST as $key => $value)
 echo $key."=".$value;
*/	

include_once $_SERVER['DOCUMENT_ROOT'] . '/psyops_function.php';

if (array_key_exists('check_submit', $_POST)) {
	
$connect = connect_mysqli();
mysqli_select_db($connect, 'setup');

$cookie = ret_cookie($connect);
$repID = $cookie[0];
$level = $cookie[1];
unset($cookie);

$idConn = connect_sqlsrv();
	
$checkSubmit = $_POST['check_submit'];
$mfg = sanitize($_POST['venPrefix']);
	
if ($_POST['checkVC'] == 'prefix') {
	$limit = 'VendorCostPlan.MACCode = ';
} else if ($_POST['checkVC'] == 'contract') {
	$limit = 'VendorCostPlan.CostPlan = ' . $mfg;
} else if ($_POST['checkVC'] == 'vendor') {
	$subVen = $mfg;
	$tsql = "select Vendor.ContractFrom, Vendor.ContractTo 
		from Vendor
		where Vendor.Number = (?)";
	$params = array($subVen);
	$options = array("Scrollable" => SQLSRV_CURSOR_KEYSET);
	$getReport = sqlsrv_query($idConn, $tsql, $params, $options);
	
	if ($getReport === false) {
		die(print_r(sqlsrv_errors()) );
	}
	$row = sqlsrv_fetch_array($getReport, SQLSRV_FETCH_NUMERIC);	
	$limit = "VendorCostPlan.CostPlan between '" . $row[0] . "' and '" . $row[1] . "'";
}

$date = (date('Y-m-d'));
$filename = 'Vendor Contract for '.$mfg;	


// Redirect output to a clients web browser (Excel2007) 
//header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
//header("Content-Disposition: attachment; filename=".$filename.".xlsx" );
// Redirect output to a clients web browser (Excel 97-2003)
echo header("Content-Type: application/vnd.ms-excel");
echo header("Content-Disposition: attachment; filename=".$filename.".xls" );
echo header('Cache-Control: max-age=0');
 

if ($checkSubmit == 9) {						// DL VENDOR CONTRACT


if (!$subVen) {
	$tsql = "select VendorCostPlan.CostPlan, VendorCostPlan.MACCode, VendorCostPlan.SKU, VendorCostPlan.Cost as 'Contract Cost', 
		ItemVendor.Cost as 'Direct Cost', Item.Unit as 'Sell UM', ItemVendor.BuyUOM as 'Buy UM', ItemVendor.CartonSize, ItemVendor.ItemId
	from VendorCostPlan left join (
		ItemVendor right join Item on ItemVendor.ItemId = Item.Id
	)
	on VendorCostPlan.ItemId = ItemVendor.ItemId
	where $limit (?)
		and ItemVendor.VendorType = (?)
	order by VendorCostPlan.SKU asc
	";
	$params = array($mfg, 'M');
} else {
	$tsql = "select VendorCostPlan.CostPlan, VendorCostPlan.MACCode, VendorCostPlan.SKU, VendorCostPlan.Cost as 'Contract Cost', 
		ItemVendor.Cost as 'Direct Cost', Item.Unit as 'Sell UM', ItemVendor.BuyUOM as 'Buy UM', ItemVendor.CartonSize, ItemVendor.ItemId
	from VendorCostPlan left join (
		ItemVendor right join Item on ItemVendor.ItemId = Item.Id
	)
		on VendorCostPlan.ItemId = ItemVendor.ItemId
	where ItemVendor.VendorType = (?)
		and $limit
	";
	$params = array('M');
}

$options = array("Scrollable" => SQLSRV_CURSOR_KEYSET);
$getReport = sqlsrv_query($idConn, $tsql, $params, $options);


if ($getReport === false) {
	die(print_r(sqlsrv_errors()));
}

/** Error reporting */
error_reporting(E_ALL);

/** Include path **/
ini_set('include_path', ini_get('include_path').'\\Classes\\');

/** PHPExcel */
include 'PHPExcel.php';

/** PHPExcel_Writer_Excel2007 */
include 'PHPExcel/Writer/Excel2007.php';

// Create new PHPExcel object
$objPHPExcel = new PHPExcel();

// Set properties
$objPHPExcel->getProperties()->setCreator("Benjamin Ingle");
$objPHPExcel->getProperties()->setLastModifiedBy("Benjamin Ingle");
$objPHPExcel->getProperties()->setTitle("Contract Detail");
$objPHPExcel->getProperties()->setSubject("Contract Detail");
$objPHPExcel->getProperties()->setDescription("Office 2002 XLS, generated using PHP classes.");
// Set column headers
$objPHPExcel->setActiveSheetIndex(0);
$objPHPExcel->getActiveSheet()->SetCellValue('A1', 'Cont');
$objPHPExcel->getActiveSheet()->SetCellValue('B1', 'Mfg');
$objPHPExcel->getActiveSheet()->SetCellValue('C1', 'Mfg');
$objPHPExcel->getActiveSheet()->SetCellValue('D1', 'Cont Cost');
$objPHPExcel->getActiveSheet()->SetCellValue('E1', 'Factored Cost');
$objPHPExcel->getActiveSheet()->SetCellValue('F1', 'Markup %');
$objPHPExcel->getActiveSheet()->SetCellValue('G1', 'P.Cost');
$objPHPExcel->getActiveSheet()->SetCellValue('H1', 'Delta, FC v PC');
$objPHPExcel->getActiveSheet()->SetCellValue('I1', 'Sell UM');
$objPHPExcel->getActiveSheet()->SetCellValue('J1', 'Buy UM');
$objPHPExcel->getActiveSheet()->SetCellValue('K1', 'Case Qty');

$objPHPExcel->getActiveSheet()->SetCellValue('L1', 'New C.Cost');
$objPHPExcel->getActiveSheet()->SetCellValue('M1', 'New F.Cost');
$objPHPExcel->getActiveSheet()->SetCellValue('N1', 'New Delta');

// Rename sheet
$objPHPExcel->getActiveSheet()->setTitle('Vendor Contract - '.$mfg);

$objPHPExcel->getActiveSheet()->getPageSetup()->setRowsToRepeatAtTopByStartAndEnd(1, 1);

// Set active sheet index to the first sheet, so Excel opens this as the first sheet
$objPHPExcel->setActiveSheetIndex(0);

// Allow setting explicit text values (eg, dept needs leading zeroes)
$type = PHPExcel_Cell_DataType::TYPE_STRING;
// Add data
$numRows = 0;
$numRows = sqlsrv_num_rows($getReport);
	$i = 2;
	while ($row = sqlsrv_fetch_array($getReport, SQLSRV_FETCH_NUMERIC)) {
			$mfg = trim($row[1]);
			$item = trim($row[2]);
		
		$tsql = "select ItemVendor.Cost
		from ItemVendor left join Item on ItemVendor.ItemId = Item.Id
		where ItemVendor.ItemId = (?) 
			and ((Item.PurchaseVendorType = ItemVendor.VendorType
			and Item.PurchaseVendorSequence = ItemVendor.Sequence) 
				or (Item.PurchaseVendorSequence = 0 and ItemVendor.VendorType = 'W' and ItemVendor.Sequence = 1))
		";
		$params = array($row[8]);
	
		$options = array("Scrollable" => SQLSRV_CURSOR_KEYSET);
		$getVCost = sqlsrv_query($idConn, $tsql, $params, $options);

		if ($getVCost === false) {
			die(print_r(sqlsrv_errors()));
		}
	
		$vCost = sqlsrv_fetch_array($getVCost, SQLSRV_FETCH_NUMERIC);
		$pCost = round($vCost[0], 2);

		
		$objPHPExcel->getActiveSheet()->setCellValue('A' . $i, $row[0]);
		$objPHPExcel->getActiveSheet()->setCellValue('B' . $i, $mfg);
		$objPHPExcel->getActiveSheet()->getCell('C' . $i)->setValueExplicit($item, $type);
		$objPHPExcel->getActiveSheet()->setCellValue('D' . $i, $row[3]);
 		$objPHPExcel->getActiveSheet()->setCellValue('E' . $i, $row[4]);
		$objPHPExcel->getActiveSheet()->setCellValue('F' . $i, '=IF(D'.$i.'=0,"",(E'.$i.'-D'.$i.')/D'.$i.')');		// formula to calculate markup (prefer the formula, vs calculating it in the script)
		$objPHPExcel->getActiveSheet()->setCellValue('G' . $i, $pCost);		
 		$objPHPExcel->getActiveSheet()->setCellValue('H' . $i, '=IF(E'.$i.'=0,"",(G'.$i.'-E'.$i.')/E'.$i.')'); 		// formula to calculate delta of p.cost vs factored cost
		$objPHPExcel->getActiveSheet()->setCellValue('I' . $i, $row[5]);
		$objPHPExcel->getActiveSheet()->setCellValue('J' . $i, $row[6]);
		$objPHPExcel->getActiveSheet()->setCellValue('K' . $i,$row[7]);
		$objPHPExcel->getActiveSheet()->setCellValue('M' . $i, '=IF(L'.$i.'=0,"",(L'.$i.'* (1 + F'.$i.')))');
		$objPHPExcel->getActiveSheet()->setCellValue('N' . $i, '=IF(M'.$i.'="","",(G'.$i.'-M'.$i.')/M'.$i.')');		
 		$i++;									// =IF(D2=0,C2,C2/D2)										
	}


// set columns to width by AutoSize (not perfect, but close enough)
$objPHPExcel->getActiveSheet()->getColumnDimension('A')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('B')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('C')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('D')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('E')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('F')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('G')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('H')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('I')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('J')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('K')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('L')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('M')->setAutoSize(true);
$objPHPExcel->getActiveSheet()->getColumnDimension('N')->setAutoSize(true);
// set certain columns to fixed width (AutoSize not close enough in this case)


$h = ($i - 1);

// can't figure out how to (or if we can) set Accounting format, using simple currency instead
$objPHPExcel->getActiveSheet()->getStyle('D2:E'.$h)->getNumberFormat()->setFormatCode(PHPExcel_Style_NumberFormat::FORMAT_CURRENCY_USD_SIMPLE);
$objPHPExcel->getActiveSheet()->getStyle('G2:G'.$h)->getNumberFormat()->setFormatCode(PHPExcel_Style_NumberFormat::FORMAT_CURRENCY_USD_SIMPLE);
$objPHPExcel->getActiveSheet()->getStyle('L2:M'.$h)->getNumberFormat()->setFormatCode(PHPExcel_Style_NumberFormat::FORMAT_CURRENCY_USD_SIMPLE);
// sets to proper percentage format, two digits to right of decimal
$objPHPExcel->getActiveSheet()->getStyle('F2:F'.$h)->getNumberFormat()->setFormatCode(PHPExcel_Style_NumberFormat::FORMAT_PERCENTAGE_00);
$objPHPExcel->getActiveSheet()->getStyle('H2:H'.$h)->getNumberFormat()->setFormatCode(PHPExcel_Style_NumberFormat::FORMAT_PERCENTAGE_00);
$objPHPExcel->getActiveSheet()->getStyle('N2:N'.$h)->getNumberFormat()->setFormatCode(PHPExcel_Style_NumberFormat::FORMAT_PERCENTAGE_00);
// formats as text, to stop dropping leading zeroes...doesn't appear to work, using setExplicit above when it puts data in the cell
//$objPHPExcel->getActiveSheet()->getStyle('B2:C'.$h)->getNumberFormat()->setFormatCode(PHPExcel_Style_NumberFormat::FORMAT_TEXT);
// centered columns
$objPHPExcel->getActiveSheet()->getStyle('A2:A'.$h)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
// right-aligned columns
$objPHPExcel->getActiveSheet()->getStyle('B2:B'.$h)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);

$objPHPExcel->getActiveSheet()->getStyle('C2:C'.$h)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);
// freeze top row (must freeze X+1 - to freeze top row, call freezePane on A2)
$objPHPExcel->getActiveSheet()->freezePane('A2');


$highestRow = $objPHPExcel->getActiveSheet()->getHighestRow();
// alternate colors on rows
for($row =1; $row<$highestRow + 2; $row++) {
	//Set the colors, mid blue for the top row, with alternating white and light blue
	if ($row == 1) $color = '7799BB'; 
	else if ($row%2==0) $color = 'FFFFFF';
	else $color = 'EBEBEB';
// set the fill type and apply the color
$objPHPExcel->getActiveSheet()->getStyle('A' . $row . ':N' . $row)->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
$objPHPExcel->getActiveSheet()->getStyle('A' . $row . ':N' . $row)->getFill()->getStartColor()->setRGB($color);
}

$color = '92D050';
$objPHPExcel->getActiveSheet()->getStyle('L1:N1')->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
$objPHPExcel->getActiveSheet()->getStyle('L1:N1')->getFill()->getStartColor()->setRGB($color);


// bolds then centers column headers
$objPHPExcel->getActiveSheet()->getStyle('A1:N1')->getFont()->setBold(true);
$objPHPExcel->getActiveSheet()->getStyle('A1:N1')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

// set A1 as the selected cell, so the sheet will always be scrolled to top left (otherwise the last row/column manipulated will be active when the file is opened)
$objPHPExcel->getActiveSheet()->setSelectedCell('A1');


// writes the file out.  Saving to php://output sets the download prompt.
// to save file to server, pass a filename to save()
//$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');
$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');

//$objWriter->save(str_replace('.php', '.xlsx', __FILE__));
$objWriter->save('php://output');


insert_timestamp($connect, 'vendor contract', 'downloaded', $repID);

// clean up
sqlsrv_free_stmt($getReport);
sqlsrv_close($idConn);
mysqli_close($connect);
unset($checkSubmit);
exit;

}									// END CHECKSUBMIT == 9

} else {
 	echo "You can't see this page without submitting the form.";
}	
?>